Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.flagstone.transform
Class FSDoAction

    java.lang.Object
      com.flagstone.transform.FSTransformObject
          com.flagstone.transform.FSMovieObject
              com.flagstone.transform.FSDoAction

All Implemented Interfaces:
  java.lang.Cloneable

    public class FSDoAction

extends FSMovieObject

FSDoAction is used to specify a sequence of actions that are executed when a frame is displayed.

Attributes
type | Identifies the data structure when it is encoded. Read-only.
actions | An array of FSActionObjects which are executed by the Flash Player when the current frame is displayed. The actions are executed in the order they appear in the array.
encodedActions | An array of bytes containing encoded actions can also be set. The encoded actions are typically generated by the parser in the Translate framework. The actions array and encodedActions cannot both be valid at the same time. Accessor methods used to set either of the attributes will set the other to null.

To define the actions for a given frame the FSDoAction object should be added to a movie after the previous frame is displayed but before the FSShowFrame object that displays the 'current' frame and triggers the actions to be executed.

Only one FSDoAction object can be used to specify the actions for a given frame. If more than one FSDoAction object is added in a single frame only the actions contained in the last FSDoAction object (before the FSShowFrame object) will be executed when the frame is displayed. The other FSDoAction objects will be ignored.

# Examples

      ArrayList actions = new ArrayList();

      actions.add(new FSPush("_root"));
      actions.add(new FSAction(FSAction.GetVariable));
      ...

      movie.add(new FSShowFrame()); // previous frame
      ...

      movie.add(new FSDoAction(actions));
      movie.add(new FSShowFrame()); // frame where actions will be executed

# History

The FSDoAction class represents the DoAction tag from the Macromedia Flash (SWF) File Format Specification. It was introduced in Flash 1.

Field Summary

Fields inherited from class com.flagstone.transform.FSMovieObject
`ButtonColorTransform, ButtonSound, DefineBitsPtr, DefineButton, DefineButton2, DefineFont, DefineFont2, DefineImage, DefineImage2, DefineJPEGImage, DefineJPEGImage2, DefineJPEGImage3, DefineMorphShape, DefineMovieClip, DefineShape, DefineShape2, DefineShape3, DefineSound, DefineText, DefineText2, DefineTextField, DefineVideo, DoAction, EnableDebugger, EnableDebugger2, Export, extendLength, FontInfo, FontInfo2, FrameLabel, Free, Import, Initialize, JPEGTables, length, LimitScript, PathsArePostscript, PlaceObject, PlaceObject2, Protect, QuicktimeMovie, RemoveObject, RemoveObject2, SerialNumber, SetBackgroundColor, ShowFrame, SoundStreamBlock, SoundStreamHead, SoundStreamHead2, StartSound, TabOrder, type, VideoFrame`

Constructor Summary
`FSDoAction(java.util.ArrayList anArray)` Constructs an FSDoAction object with an array of actions.
`FSDoAction(byte[] bytes)` Constructs an FSDoAction object with an array of encoded actions generated by the classes in Translate.
`FSDoAction(FSCoder coder)` Construct an FSDoAction object, initialising it with values decoded from an encoded object.
`FSDoAction(FSDoAction obj)` Constructs an FSDoAction object by copying values from an existing object.

Method Summary
`void` | `add(FSActionObject anAction)` Adds the action object to the array of actions.
`void` | `appendDescription(java.lang.StringBuffer buffer, int depth)` AppendDescription is used to present a string description of the object including all nested objects up to a specified depth.
`java.lang.Object` | `clone()` Creates a deep copy of the entire object.
`void` | `decode(FSCoder coder)`
`void` | `encode(FSCoder coder)`
`boolean` | `equals(java.lang.Object anObject)` Returns true if anObject is equal to this one.
`java.util.ArrayList` | `getActions()` Get the array of actions that are executed when the frame is displayed.
`byte[]` | `getEncodedActions()` Get the array of encoded actions that are executed when the frame is displayed.
`int` | `length(FSCoder coder)`
`void` | `setActions(java.util.ArrayList anArray)` Set the array of actions that will be executed when the next ShowFrame tag is executed by the Flash Player.
`void` | `setEncodedActions(byte[] bytes)` Set the array of encoded actions generated by the classes in the Translate framework.

Methods inherited from class com.flagstone.transform.FSMovieObject
`getType`

Methods inherited from class com.flagstone.transform.FSTransformObject
`name, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### FSDoAction

    public FSDoAction(FSCoder coder)

  Construct an FSDoAction object, initialising it with values decoded from an encoded object.

  Parameters:
    `coder` - an FSCoder containing the binary data.

### FSDoAction

    public FSDoAction(java.util.ArrayList anArray)

  Constructs an FSDoAction object with an array of actions.

  Parameters:
    `anArray` - the array of action objects.

### FSDoAction

    public FSDoAction(byte[] bytes)

  Constructs an FSDoAction object with an array of encoded actions generated by the classes in Translate.

  Parameters:
    `bytes` - an array of encoded action objects.

### FSDoAction

    public FSDoAction(FSDoAction obj)

  Constructs an FSDoAction object by copying values from an existing object.

  Parameters:
    `obj` - an FSDoAction object.

Method Detail

### add

    public void add(FSActionObject anAction)

  Adds the action object to the array of actions. If the object already contains encoded actions then they will be deleted.

  Parameters:
    `anAction` - an object belonging to a class derived from FSActionObject.

### getActions

    public java.util.ArrayList getActions()

  Get the array of actions that are executed when the frame is displayed.

  Returns:
    the array of action objects.

### setActions

    public void setActions(java.util.ArrayList anArray)

  Set the array of actions that will be executed when the next ShowFrame tag is executed by the Flash Player. If the object already contains encoded actions then they will be deleted.

  Parameters:
    `anArray` - the array of action objects.

### getEncodedActions

    public byte[] getEncodedActions()

  Get the array of encoded actions that are executed when the frame is displayed.

  Returns:
    the array of action objects or null if the actions have been decoded.

### setEncodedActions

    public void setEncodedActions(byte[] bytes)

  Set the array of encoded actions generated by the classes in the Translate framework. If the object already contains an array of actions then they will be deleted.

  Parameters:
    `bytes` - the array of encoded actions.

### clone

    public java.lang.Object clone()

  Description copied from class: `FSTransformObject`
  Creates a deep copy of the entire object.

  Overrides:
    `clone` in class `FSTransformObject`
  Returns:
    a copy of the object.

### equals

    public boolean equals(java.lang.Object anObject)

  Description copied from class: `FSMovieObject`
  Returns true if anObject is equal to this one. Objects are considered equal if they would generate identical binary data when they are encoded to a Flash file.

  Overrides:
    `equals` in class `FSMovieObject`
  Returns:
    true if this object would be identical to anObject when encoded.

### appendDescription

    public void appendDescription(java.lang.StringBuffer buffer,
                                  int depth)

  Description copied from class: `FSTransformObject`
  AppendDescription is used to present a string description of the object including all nested objects up to a specified depth. This method provide a more controlled way of creating a string representation of an object since large objects such as font or shape definitions can contain dozens of nested objects. The representation of the object is appended to the StringBuffer, showing the name of the class and values of the attributes it contains. If the object contains any attributes that are objects then the object graph will be traversed up to the specified depth. If objects are nested at a level less than specified depth then the full string representation of the object is displayed. For objects at the specified depth only the name of the class is displayed. Any objects below this depth are not displayed.

  Overrides:
    `appendDescription` in class `FSMovieObject`
  Parameters:
    `buffer` - a StringBuffer to which the description of each object is appended.
    `depth` - the maximum level of nesting up to which objects will be displayed.

### length

    public int length(FSCoder coder)

  Overrides:
    `length` in class `FSMovieObject`

### encode

    public void encode(FSCoder coder)

  Overrides:
    `encode` in class `FSMovieObject`

### decode

    public void decode(FSCoder coder)

  Overrides:
    `decode` in class `FSMovieObject`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD